/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package com.microsoft.azure.keyvault.models;

import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * Parameters for the issuer of the X509 component of a certificate.
 */
public class IssuerParameters {
    /**
     * Name of the referenced issuer object or reserved names e.g. 'Self',
     * 'Unknown'.
     */
    private String name;

    /**
     * Type of certificate to be requested from the issuer provider.
     */
    @JsonProperty(value = "cty")
    private String certificateType;

    /**
     * Get the name value.
     *
     * @return the name value
     */
    public String name() {
        return this.name;
    }

    /**
     * Set the name value.
     *
     * @param name the name value to set
     * @return the IssuerParameters object itself.
     */
    public IssuerParameters withName(String name) {
        this.name = name;
        return this;
    }

    /**
     * Get the certificateType value.
     *
     * @return the certificateType value
     */
    public String certificateType() {
        return this.certificateType;
    }

    /**
     * Set the certificateType value.
     *
     * @param certificateType the certificateType value to set
     * @return the IssuerParameters object itself.
     */
    public IssuerParameters withCertificateType(String certificateType) {
        this.certificateType = certificateType;
        return this;
    }

}
