/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package com.microsoft.azure.keyvault.models;

import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * Details of the organization of the certificate issuer.
 */
public class OrganizationDetails {
    /**
     * Id of the organization.
     */
    private String id;

    /**
     * Details of the organization administrator.
     */
    @JsonProperty(value = "admin_details")
    private List<AdministratorDetails> adminDetails;

    /**
     * Get the id value.
     *
     * @return the id value
     */
    public String id() {
        return this.id;
    }

    /**
     * Set the id value.
     *
     * @param id the id value to set
     * @return the OrganizationDetails object itself.
     */
    public OrganizationDetails withId(String id) {
        this.id = id;
        return this;
    }

    /**
     * Get the adminDetails value.
     *
     * @return the adminDetails value
     */
    public List<AdministratorDetails> adminDetails() {
        return this.adminDetails;
    }

    /**
     * Set the adminDetails value.
     *
     * @param adminDetails the adminDetails value to set
     * @return the OrganizationDetails object itself.
     */
    public OrganizationDetails withAdminDetails(List<AdministratorDetails> adminDetails) {
        this.adminDetails = adminDetails;
        return this;
    }

}
