/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.management.network;


/**
 * VirtualNetworkGatewaySku details.
 */
public class VirtualNetworkGatewaySku {
    /**
     * Gateway sku name -Basic/HighPerformance/Standard/UltraPerformance.
     * Possible values include: 'Basic', 'HighPerformance', 'Standard',
     * 'UltraPerformance'.
     */
    private VirtualNetworkGatewaySkuName name;

    /**
     * Gateway sku tier -Basic/HighPerformance/Standard/UltraPerformance.
     * Possible values include: 'Basic', 'HighPerformance', 'Standard',
     * 'UltraPerformance'.
     */
    private VirtualNetworkGatewaySkuTier tier;

    /**
     * The capacity.
     */
    private Integer capacity;

    /**
     * Get the name value.
     *
     * @return the name value
     */
    public VirtualNetworkGatewaySkuName name() {
        return this.name;
    }

    /**
     * Set the name value.
     *
     * @param name the name value to set
     * @return the VirtualNetworkGatewaySku object itself.
     */
    public VirtualNetworkGatewaySku withName(VirtualNetworkGatewaySkuName name) {
        this.name = name;
        return this;
    }

    /**
     * Get the tier value.
     *
     * @return the tier value
     */
    public VirtualNetworkGatewaySkuTier tier() {
        return this.tier;
    }

    /**
     * Set the tier value.
     *
     * @param tier the tier value to set
     * @return the VirtualNetworkGatewaySku object itself.
     */
    public VirtualNetworkGatewaySku withTier(VirtualNetworkGatewaySkuTier tier) {
        this.tier = tier;
        return this;
    }

    /**
     * Get the capacity value.
     *
     * @return the capacity value
     */
    public Integer capacity() {
        return this.capacity;
    }

    /**
     * Set the capacity value.
     *
     * @param capacity the capacity value to set
     * @return the VirtualNetworkGatewaySku object itself.
     */
    public VirtualNetworkGatewaySku withCapacity(Integer capacity) {
        this.capacity = capacity;
        return this;
    }

}
