/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.management.redis.implementation;

import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * Redis cache access keys.
 */
public class RedisAccessKeysInner {
    /**
     * The current primary key that clients can use to authenticate with redis
     * cache.
     */
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private String primaryKey;

    /**
     * The current secondary key that clients can use to authenticate with
     * redis cache.
     */
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private String secondaryKey;

    /**
     * Get the primaryKey value.
     *
     * @return the primaryKey value
     */
    public String primaryKey() {
        return this.primaryKey;
    }

    /**
     * Get the secondaryKey value.
     *
     * @return the secondaryKey value
     */
    public String secondaryKey() {
        return this.secondaryKey;
    }

}
