/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.management.search;


/**
 * Defines the SKU of an Azure Search Service, which determines price tier and
 * capacity limits.
 */
public class Sku {
    /**
     * The SKU of the Search service. Possible values include: 'free',
     * 'standard', 'standard2'.
     */
    private SkuType name;

    /**
     * Get the name value.
     *
     * @return the name value
     */
    public SkuType name() {
        return this.name;
    }

    /**
     * Set the name value.
     *
     * @param name the name value to set
     * @return the Sku object itself.
     */
    public Sku withName(SkuType name) {
        this.name = name;
        return this;
    }

}
